/**
 *  ex01.cc
 *  Utiliza a classe Book
 *
 *  Autor: Moacir Ponti Jr
 *  Fev/2011
 */

#include "Book.h"
#include <stdlib.h>
#include <stdio.h>

int main (int argc, char *argv[]){

    // imprime tamanho de um objeto Book
    // o tamanho depende do sistema (32 bits, 64 bits, ...)
    printf("\n%ld\n", sizeof(Book));
		
    // declaracao estatica de dois objetos da classe Book
    // o objeto b1 sera alocado na pilha (stack)
    Book b1;
    char *t1 = (char *)malloc(sizeof(char)*40);
    strcpy(t1,"O Guia do Mochileiro das Galaxias");
    
    b1.setCode(101); // chamada de metodo 
    b1.setPrice(19.9); 
    b1.setAuthor("Adams"); 
    b1.setTitle(t1);

    printf("\nb1: %s\n%s\n%lf\n%d\n",
	      b1.getTitle(),
	      b1.getAuthor(),
	      b1.getPrice(),
	      b1.getCode());

    // em C++ permanece a passagem de parametros por referencia
    // entao t1 pode ser modificado dentro do metodo setTitle
    printf("\nApos passar t1 por referencia ao metodo setTitle(): %s\n", t1);

    // a variavel b2 (ponteiro) fica na stack
    // mas o objeto (e seu conteudo) é alocado dinamicamente na HEAP
    // o comando new executa a alocacao dinamica apropriada para objetos
    // Book *b2 = (Book *)malloc(sizeof(Book)); <- tambem funciona, mas nao e ideal.
    Book *b2 = new Book(); 
    strcpy(t1,"Harry Potter and The Deadly Hallows");    
    
    // como b2 foi alocado dinamicamente usamos seta
    b2->setCode(201); 
    b2->setPrice(59.9);
    b2->setAuthor("Rowling"); 
    b2->setTitle(t1);

    printf("\nb2: %s\n%s\n%lf\n%d\n",
 	      b2->getTitle(),
 	      b2->getAuthor(),
 	      b2->getPrice(),
 	      b2->getCode());

    // setAuthor e setTitle realizam nova alocacao dinamica
    // >> o que sera que acontece na memoria?
    strcpy(t1,"World War Z");    
    b1.setAuthor("Brooks");
    b1.setTitle(t1);

    printf("\nb1 (novo set): %s\n%s\n%lf\n%d\n",
	      b1.getTitle(),
	      b1.getAuthor(),
	      b1.getPrice(),
	      b1.getCode());
		
    return 0;
}